window.onload = init;

var vencidas = 0;
var perdidas = 0;
var jogador = "";

function init() {
	
	var binicio = document.getElementById("binicio");
	binicio.onclick = iniciaJogo;

	var bjanela = document.getElementById("bjanela");
	bjanela.onclick = escondeJanela;

	atualizaPlacar();

	createDebug();
}

function iniciaJogo() {

	desligaTabuleiro();

	var radio = document.getElementsByName("jogador");
	if (radio[0].checked) jogador = "x";
	else jogador = "o";
	/* envia requisio... volta deve ir para processa requisio */
	request = createRequest();
	if (request == null) {
		window.alert("Impossvel criar requisio AJAX");
		return;
		}
	var url="velha.php?start=" + escape(jogador);
	request.open("GET",url,true);
	request.onreadystatechange = processResponse;
	request.send(null);

	play("snd_start");
	window.alert("Jogador: " + jogador);
}

function processResponse() {
   if (request.readyState == 4) {
      if (request.status == 200) {
         pintaTabuleiro(request.responseText);
      }
   }
}


function pintaTabuleiro(dados) {
    /* Extrai valores */
    //dados = "xxxXXXooo ";
    var c = new Array();
    for (i=0; i<9; i++) {
        c[i] = dados.substr(i,1);
        }
    var win = dados.substr(9,1);

    for (i=0; i<9; i++) {
        var cel = document.getElementById("c"+i);
        var ocel = document.getElementById("c"+i+"s");
        if (c[i] == "x") {
            cel.onclick = "";
            cel.className = "xsel";
            ocel.style.visibility = "hidden";
            }
        else if (c[i] == "X") {
            cel.onclick = "";
            cel.className = "Xsel";
            ocel.style.visibility = "hidden";
            }
        else if (c[i] == "o") {
            cel.onclick = "";
            cel.className = "osel";
            ocel.style.visibility = "hidden";
            }
        else if (c[i] == "O") {
            cel.onclick = "";
            cel.className = "Osel";
            ocel.style.visibility = "hidden";
            }
        else {
            cel.onclick = click;
            cel.className = "nsel";
            ocel.style.visibility = "visible";
            }
    }

    /* Controla Vitrias / Derrotas */
    if (win == "v") {
	play("snd_win");
        mostraJanela("Voc venceu!","Parabns!","Ser que voc consegue vencer novamente?");
        localStorage.velha_vencidas = Number(localStorage.velha_vencidas)+1;
        vencidas++;
        }
    else if (win == "p") {
	play("snd_lost");
        mostraJanela("Voc perdeu!","Que triste!","Desejo mais sorte na prxima vez!");
        localStorage.velha_perdidas = Number(localStorage.velha_perdidas)+1;
        perdidas++;
        }
    else if (win == "e") {
        mostraJanela("Deu velha!","Tente Novamente!","Desejo mais sorte na prxima vez!");
        }
    else escondeJanela();

    atualizaPlacar();

}

function click() {
	/* Desliga todas as posies para click... */
	desligaTabuleiro();
	
	/* envia requisio... volta deve ir para processa requisio */
	request = createRequest();
	if (request == null) {
		window.alert("Impossvel criar requisio AJAX");
		return;
		}
	var url="velha.php?cel=" + escape(this.id);
	request.open("GET",url,true);
	request.onreadystatechange = processResponse;
	request.send(null);

	play("snd_pop");
}

function desligaTabuleiro() {
    for (i=0; i<9; i++) {
        var cel = document.getElementById("c"+i);
        var ocel = document.getElementById("c"+i+"s");
        cel.onclick = "";
        ocel.style.visibility = "hidden";
        }
}

function atualizaPlacar() {

    if (localStorage.velha_vencidas == null) {
         localStorage.velha_vencidas = 0;
         localStorage.velha_perdidas = 0;
    }
    var div = document.getElementById("status_hoje");
    div.innerHTML = "<strong>Agora</strong> V: " + vencidas + " / P: " + perdidas;
    var div = document.getElementById("status_total");
    div.innerHTML = "<strong>Total</strong> V: " + localStorage.velha_vencidas + " / P: " + localStorage.velha_perdidas;
}


function escondeJanela() {
	/* Some com a janela */
	var jan = document.getElementById("janela");
	jan.style.visibility = "hidden";
	
	/* Limpa elementos da janela */
	var area = document.getElementById("jan_texto");
	var head = area.getElementsByTagName("h1");
	if (head.length > 0) area.removeChild(head[0]);
	head = area.getElementsByTagName("h2");
	if (head.length > 0) area.removeChild(head[0]);
	head = area.getElementsByTagName("h3");
	if (head.length > 0) area.removeChild(head[0]);
}

function mostraJanela(msg1, msg2, msg3) {
	var linha1 = document.createElement("h2");
	linha1.innerHTML = msg1;
	var linha2 = document.createElement("h1");
	linha2.innerHTML = msg2;
	var linha3 = document.createElement("h3");
	linha3.innerHTML = msg3;

	var area = document.getElementById("jan_texto");
	area.appendChild(linha1);
	area.appendChild(linha2);
	area.appendChild(linha3);

	var jan = document.getElementById("janela");
	jan.style.visibility = "visible";
}

function play(id) {
	document.getElementById(id).play();
}


function createDebug() {
   var div = document.createElement("div");
   div.id = "debug";
   div.style.position = "absolute";
   div.style.right = "0px";
   div.style.top = "0px";
   div.style.borderWidth = "2px";
   div.style.borderColor = "blue";
   div.style.borderStyle = "solid";
   div.style.padding = "5px";

   /* Cria Elementos Manualmente */
   var par = document.createElement("p");
   div.appendChild(par);

   var inarea = document.createElement("input");
   inarea.type = "text";
   inarea.id = "dbg_inarea";
   par.appendChild(inarea);

   var bteste = document.createElement("input");
   bteste.type = "button";
   bteste.value = "Testar!";
   bteste.id = "dbg_bteste";
   par.appendChild(bteste);

   /* Cria elementos com innerHTML */
   //div.innerHTML = "<p><input type='text' id='dbg_inarea' /><input type='button' value='teste' id='dbg_bteste'/></p>";//
   //var inarea = document.getElementById("dbg_inarea");
   //var bteste = document.getElementById("dbg_bteste");

   document.body.appendChild(div);

   // Associa funo de debug ao boto
   bteste.onclick = runDebug;

}

function runDebug() {
   var inarea = document.getElementById("dbg_inarea");
   pintaTabuleiro(inarea.value);
}






function getStyle(oElm, strCssRule){
  var strValue = "";
  if(document.defaultView && document.defaultView.getComputedStyle){
    strValue = document.defaultView.getComputedStyle(oElm, "").getPropertyValue(strCssRule);
  }
  else if(oElm.currentStyle){
    strCssRule = strCssRule.replace(/\-(\w)/g, function (strMatch, p1){
      return p1.toUpperCase();
    });
    strValue = oElm.currentStyle[strCssRule];
  }
  return strValue;
}

